require_relative '../lib/mutagen'

describe SpecBlock do

  let(:file_types) { Mutagen::METHOD_TYPES.map { |mt| "#{mt}_block" } }
  file_types.each do |file_type|
    file_path = File.expand_path("fixtures/#{file_type}.rb", __FILE__)
    let(file_type) { File.read(file_path) }
  end

  let(:spec_block) { SpecBlock.new }

  describe '#title' do
    context 'given a bang block' do
      it 'returns a bang title' do
        spec_block.text = bang_block
        expect(spec_block.title).to eq '#my_method!'
      end
    end

    context 'given a class block' do
      it 'returns a class title' do
      end
    end

    context 'given an instance block' do
      it 'returns an instance title' do
      end
    end

    context 'given a plain block' do
      it 'returns a plain title' do
      end
    end

    context 'given a predicate block' do
      it 'returns a predicate title' do
      end
    end

    context 'given a writer block' do
      it 'returns a writer title' do
      end
    end
  end

  describe '#body' do
    it 'returns the body of the block' do
      file_types.each do |file_type|
        spec_block.text = send(file_type)
        expect(spec_block.body).to eq "  it 'does something' do\n" <<
                                      "    expect('blah').to be_true\n" <<
                                      "  end\n"
      end
    end
  end

  describe '#filename' do
    context 'given a bang block' do
      it 'returns a bang filename' do
      end
    end

    context 'given a class block' do
      it 'returns a class filename' do
      end
    end

    context 'given an instance block' do
      it 'returns an instance filename' do
      end
    end

    context 'given a plain block' do
      it 'returns a plain filename' do
      end
    end

    context 'given a predicate block' do
      it 'returns a predicate filename' do
      end
    end

    context 'given a writer block' do
      it 'returns a writer filename' do
      end
    end

  end

end
